'use strict';

const http = require('http');
const queryString = require('query-string');

const Request = http.IncomingMessage.prototype;
const Response = http.ServerResponse.prototype;

Object.defineProperty(Request, 'params', { get: function() {
  if(this._params)
    return this._params;
   
  this._params = queryString(this.url.split('?')[1]);
  
  return this._params;
}});

Object.defineProperty(Request, 'body', { get: async function() {
  if(this._body) 
    return this._body;
  
  this._body = await (new Promise((resolve, reject) => {
    this.on('data', c => resolve(c.toString()))
    .on('end', () => resolve('{}'))
  }));
  
  return this._body;
}});

module.exports = { Request, Response };